<template>
  <v-container class="text-center">
    <h1>Articles</h1>
    <v-row>
      <v-col
          v-for="post in articles"
          :key="post.id"
          md="4"
          sm="6"
      >
        <v-card
            class="d-flex flex-column"
            height="100%"
        >
          <router-link :to="'/articles/' + post.id">
            <v-img
                height="250"
                :src="post.preview_image"
                :alt="post.name"
            ></v-img>
          </router-link>
          <v-card-text>{{ post.date }}</v-card-text>

          <v-card-title>{{ post.name }}</v-card-title>

          <v-card-text>{{ post.shortDesc }}</v-card-text>
          <v-card-text class="mt-auto"><router-link :to="'/articles/' + post.id">Learn more</router-link></v-card-text>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
// @ is an alias to /src

export default {
  data () {
    return {
      loading: false,
      error: null
    }
  },
  created () {
    this.fetchData()
  },
  watch: {
    '$route': 'fetchData'
  },
  methods: {
    fetchData () {
      this.error = this.post = null
      this.loading = true
      this.$store.dispatch('getArticles')
          .then(() => {
            this.loading = false
          })
          .catch(err => this.error = err.toString())
    }
  },
  computed: {
    articles () {
      return this.$store.state.articles
    }
  }
}
</script>

<style>
.post__content {
  border: 1px solid rgba(0, 0, 0, 0.12);
  border-radius: 12px;
  height: 100%;
}

.post__image {
  max-height: 240px;
}

.v-card__title {
  display: block;
}
</style>
